Index: org.gvsig.chart/trunk/org.gvsig.chart/org.gvsig.chart.app/org.gvsig.chart.app.legendplugin/src/main/java/org/gvsig/project/documents/view/legend/LinkedChartLegend.java
===================================================================
--- org.gvsig.chart/trunk/org.gvsig.chart/org.gvsig.chart.app/org.gvsig.chart.app.legendplugin/src/main/java/org/gvsig/project/documents/view/legend/LinkedChartLegend.java	(revision 570)
+++ org.gvsig.chart/trunk/org.gvsig.chart/org.gvsig.chart.app/org.gvsig.chart.app.legendplugin/src/main/java/org/gvsig/project/documents/view/legend/LinkedChartLegend.java	(revision 571)
@@ -51,518 +54,560 @@
 import org.jfree.chart.LegendItem;
 
 @Deprecated
-public final class LinkedChartLegend extends BasePieChartLegend implements ILinkedChartLegend{
+public final class LinkedChartLegend extends BasePieChartLegend implements ILinkedChartLegend {
 
-	public static class RegisterLegend implements Callable {
+    public static class RegisterLegend implements Callable {
 
-		public Object call() throws Exception {
-	        MapContextManager manager = MapContextLocator.getMapContextManager();
+        public Object call() throws Exception {
+            MapContextManager manager = MapContextLocator.getMapContextManager();
 
             manager.registerLegend(IChartLegend.LINKED_LEGEND_NAME,
-            		LinkedChartLegend.class);
+                    LinkedChartLegend.class);
 
-			return Boolean.TRUE;
-		}
+            return Boolean.TRUE;
+        }
 
-	}
+    }
 
+    public static final String LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME = "LinkedChartLegend";
 
-	public static final String LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME = "LinkedChartLegend";
+    private static final String FIELD_NAMES = "FieldLegendNames";
+    private static final String FIELD_LABEL_NAMES = "FieldLabelNames";
+    private static final String FIELD_LABEL_COLOR = "FieldLabelColor";
 
+    protected Map<String, List> indexHash;
+    private String linkedField;
+    private String groupedByField = "";
+    private List<String> linkedFieldValues;
+    private String[] linkedFieldTableNames;
+    private String[] linkedFieldName;
+    private String linkedTable;
+    private boolean originSelected;
+    private boolean destinationSelected;
+    private String[] linkedFields;
 
-	protected Map<String,List> indexHash = new HashMap<String,List>();
-	private String linkedField;
-	private String groupedByField="";
-	private List<String> linkedFieldValues;
-	private String[] linkedFieldTableNames;
-	private String[] linkedFieldName;
-	private String linkedTable;
-	private boolean originSelected;
-	private boolean destinationSelected;
-	private String[] linkedFields;
+    private String timeField;
 
+    private String legendType;
 
-	private String timeField;
+    public LinkedChartLegend() {
+        this.indexHash = new HashMap<>();
+    }
 
+    @Override
+    public void draw(BufferedImage image, Graphics2D g, ViewPort viewPort,
+            Cancellable cancel, double scale, Map queryParameters,
+            ICoordTrans coordTrans, FeatureStore featureStore,
+            FeatureQuery featureQuery) throws LegendException {
+        FeatureSelection fsel;
+        try {
+            this.featSelection = featureStore.getFeatureSelection();
+            System.out.println("LINKEDCHARTLEGEND: " + featSelection.getSelectedCount() + " seleccionados.");
+        } catch (DataException e) {
+            e.printStackTrace();
+        }
 
-	private String legendType;
+        super.draw(image, g, viewPort, cancel, scale, queryParameters, coordTrans,
+                featureStore, featureQuery);
+    }
 
-	public LinkedChartLegend(){
-	}
+    /**
+     * Devuelve un array con los campos seleccionados a pintar de la capa
+     * enlazada
+     *
+     * @return
+     */
+    public String[] getLinkedClassifyingFieldNames() {
+        return getClassifyingFieldNames();
+    }
 
-	@Override
-	public void draw(BufferedImage image, Graphics2D g, ViewPort viewPort,
-			Cancellable cancel, double scale, Map queryParameters,
-			ICoordTrans coordTrans, FeatureStore featureStore,
-			FeatureQuery featureQuery) throws LegendException {
-		FeatureSelection fsel;
-		try {
-			this.featSelection = featureStore.getFeatureSelection();
-			System.out.println("LINKEDCHARTLEGEND: " + featSelection.getSelectedCount() + " seleccionados.");
-		} catch (DataException e) {
-			e.printStackTrace();
-		}
+    @Override
+    public String[] getClassifyingFieldNames() {
+        return this.linkedFieldName;
+    }
 
+    @Override
+    public void setLinkedFieldName(String[] fieldName) {
+        this.linkedFieldName = fieldName;
+        updateSymbols();
+    }
 
-		super.draw(image, g, viewPort, cancel, scale, queryParameters, coordTrans,
-				featureStore, featureQuery);
-	}
+    @Override
+    public void setDataHash(Map<String, List> hash) {
+        this.indexHash = hash;
+    }
 
-	/**
-	 * Devuelve un array con los campos seleccionados a pintar de la capa enlazada
-	 * @return
-	 */
-	public String[] getLinkedClassifyingFieldNames() {
-		return getClassifyingFieldNames();
-	}
+    @Override
+    public Set<String> getLinkedFieldValues() {
+        return this.indexHash.keySet();
+    }
 
+    public void setLinkedFieldValues(List<String> values) {
+        this.linkedFieldValues = values;
+        updateSymbols();
+    }
 
-	@Override
-	public String[] getClassifyingFieldNames() {
-		return this.linkedFieldName;
-	}
+    @Override
+    public Map<String, List> getLinkedData() {
 
-	public void setLinkedFieldName(String[] fieldName){
-		this.linkedFieldName = fieldName;
-		updateSymbols();
-	}
+        indexHash = new HashMap<>();
 
-	public void setDataHash(Map<String,List> hash){
-		this.indexHash  = hash;
-	}
+        ApplicationManager appManager = ApplicationLocator.getManager();
+        final Project project = appManager.getCurrentProject();
 
+        TableDocument selDoc = (TableDocument) project.getDocument(this.linkedTable,
+                TableManager.TYPENAME);
 
+        if (selDoc != null) {
+            try {
+                FeatureType featType = selDoc.getStore().getDefaultFeatureType();
+                FeatureAttributeDescriptor[] atts = featType.getAttributeDescriptors();
 
-	public Set<String> getLinkedFieldValues() {
-		return this.indexHash.keySet();
-	}
+                FeatureSelection fsel = selDoc.getStore().getFeatureSelection();
+                FeatureSet fs = selDoc.getStore().getFeatureSet();
 
-	public void setLinkedFieldValues(List<String> values){
-		this.linkedFieldValues = values;
-		updateSymbols();
-	}
+                DisposableIterator it = null;
+                if (this.destinationSelected) {
+                    it = fsel.fastIterator();
+                } else {
+                    it = fs.fastIterator();
+                }
 
-	public Map<String, List> getLinkedData() {
+                while (it.hasNext()) {
+                    Feature f = (Feature) it.next();
 
-	    indexHash = new HashMap<String,List>();
+                    String key = f.getString(this.linkedField);
+                    if (key != null) {
+                        List<Map<String, Double>> array = indexHash.get(key);
+                        if (array == null) {
+                            array = new ArrayList<>();
+                            indexHash.put(key, array);
+                        }
+                        if (array instanceof DelegatedList) {
+                            List<Map<String, Double>> auxarray = new ArrayList<>();
+                            for (int i = 0; i < array.size(); i++) {
+                                auxarray.add(array.get(i));
+                            }
+                            array = auxarray;
+                        }
 
-		ApplicationManager appManager = ApplicationLocator.getManager();
-		final Project project = appManager.getCurrentProject();
+                        Map<String, Double> elem = new HashMap<>();
+                        for (String field : getLinkedFields()) {
+                            if (!field.equalsIgnoreCase(key)) {
+                                Double value = f.getDouble(field);
+                                elem.put(field, value);
+                            }
+                        }
+                        String xAxis = this.timeField;
+                        if (StringUtils.isNotEmpty(xAxis)) {
+                            Double value = f.getDouble(xAxis);
+                            elem.put(xAxis, value);
+                        }
+                        array.add(elem);
+                    }
+                }
 
-		TableDocument selDoc = (TableDocument) project.getDocument(this.linkedTable,
-			TableManager.TYPENAME);
+                it.dispose();
+            } catch (DataException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
 
-		if (selDoc != null) {
-					try {
-						FeatureType featType = selDoc.getStore().getDefaultFeatureType();
-						FeatureAttributeDescriptor[] atts = featType.getAttributeDescriptors();
+        } else {
+            throw new RuntimeException("No se encuentra la tabla "
+                    + this.linkedTable);
+        }
 
-						FeatureSelection fsel = selDoc.getStore().getFeatureSelection();
-						FeatureSet fs = selDoc.getStore().getFeatureSet();
+        return indexHash;
+    }
 
-						DisposableIterator it = null;
-						if (this.destinationSelected) {
-							it = fsel.fastIterator();
-						}
-						else {
-							it = fs.fastIterator();
-						}
+    @Override
+    public ISymbol getSymbolByFeature(Feature feat) throws MapContextException {
 
-						while (it.hasNext()) {
-							Feature f = (Feature) it.next();
+        if (this.onlySelection) {
+            if (!featSelection.isSelected(feat)) {
+                return null;
+            }
+        }
+        String name = "";
+        if (getClassifyingFieldNames() != null && getClassifyingFieldNames().length > 0) {
+            name = feat.getString(getClassifyingFieldNames()[0]);
+        } else {
+            return null;
+        }
+        Set<String> indexes = getLinkedFieldValues();
+        if (!indexes.contains(name)) {
+            return null;
+        }
 
-							String key = f.getString(this.linkedField);
-							if(key != null){
-								List<Map<String,Double>> array = indexHash.get(key);
-								if(array == null){
-									array = new ArrayList<Map<String,Double>>();
-									indexHash.put(key, array);
-								}
-								if(array instanceof DelegatedList){
-									List<Map<String,Double>> auxarray = new ArrayList<Map<String,Double>>();
-									for(int i=0;i<array.size();i++){
-										auxarray.add(array.get(i));
-									}
-									array = auxarray;
-								}
+        // TODO: AQUÍ PRODRÍAMOS RECUPERAR VARIOS SIMBOLOS. POR AHORA, SUPONEMOS QUE EL DEFAULTSYMBOL ES EL QUE TIENE EL CHARTSYMBOL
+        symbol = (IChartSymbol) getDefaultSymbol();
+        if (symbol == null) {
+            symbol = (IChartSymbol) MapContextLocator
+                    .getSymbolManager().createSymbol(IChartSymbol.SYMBOL_NAME);
 
-								Map<String,Double> elem = new HashMap<String,Double>();
-								for(int i=0;i<getLinkedFields().length; i++) {
-									String field = getLinkedFields()[i];
-									if(!field.equalsIgnoreCase(key)){
-										Double value = f.getDouble(field);
-										if(value != null){
-											elem.put(field, value);
-										}
-									}
-								}
-								String xAxis = this.timeField;
-								if(xAxis != "" && xAxis!=null) {
-										Double value = f.getDouble(xAxis);
-										if(value != null){
-											elem.put(xAxis, value);
-										}
-								}
-								array.add(elem);
-							}
-						}
+        }
+        symbol.setOnlySelection(onlySelection);
+        double size = 0;
 
-						it.dispose();
-					} catch (DataException e) {
-						// TODO Auto-generated catch block
-						e.printStackTrace();
-					}
+        ChartDataSet dataSet = ChartLocator.getServiceManager()
+                .getChartManager().createChartDataSet();
 
-		}else{
-			throw new RuntimeException("No se encuentra la tabla "
-					+ this.linkedTable);
-		}
+        ChartService cs = symbol.getChart();
+        if (StringUtils.equals(cs.getChartType(), "BarsChart")) {
+            addBarsDataSetInfo(dataSet, name);
+        } else {
+            addPieDataSetInfo(dataSet, name);
+        }
+        cs.getChartProperties().setChartDimension(this.is3D);
 
-		return indexHash;
-	}
+        String[] names = getFieldNames();
+        if (names != null) {
+            cs.setChartDataSet(dataSet);
+            List<ChartSerieEntity> lst = cs.getChartLegendItems();
 
+            for (int j = 0; j < names.length; j++) {
+                colors[j] = getSymbolByValue(names[j]).getColor();
+                LegendItem item = new LegendItem(names[j], colors[j]);
+                item.setSeriesKey(names[j]);
+                ChartSerieEntity e = cs.createNewChartSerieEntity(item);
+                if (e != null) {
+                    lst.add(e);
+                }
+            }
+            cs.setCategoriesPaint(Arrays.asList(colors));
+        }
+        double separation = sizeTo - sizeFrom;
 
-	@Override
-	public ISymbol getSymbolByFeature(Feature feat) throws MapContextException {
+        switch (sizeOption) {
+            case IChartSymbol.SIZESUM:
+                if (isActiveLimits()) {
+                    double difFeat = maxFeature - minFeature;
+                    double step = difFeat / separation;
+                    size = sizeFrom + ((size - minFeature) / step);
+                }
+                symbol.setSize(size);
+                break;
+            case IChartSymbol.SIZEFIELD:
+                if (separation == 0) {
+                    separation = 1;
+                }
+                double value = feat.getDouble(getFieldSize());
+                if (!getFieldNormalize().equals("---")) {
+                    double normalize = feat.getDouble(getFieldNormalize());
+                    if (normalize != 0) {
+                        value = value / normalize;
+                    }
+                    if (isActiveLimits()) {
+                        size = sizeFrom + (value * separation);
+                    } else {
+                        size = value;
+                    }
+                } else {
+                    if (isActiveLimits()) {
+                        double difFeat = maxFeature - minFeature;
+                        double step = difFeat / separation;
+                        size = sizeFrom + ((value - minFeature) / step);
+                    } else {
+                        size = value;
+                    }
+                }
+                symbol.setSize(size);
+                break;
+            default:
+                symbol.setSize(getSize());
+                break;
+        }
+        return symbol;
+    }
 
-		if (this.onlySelection)
-			if (!featSelection.isSelected(feat))
-				return null;
-		String name="";
-		if(getClassifyingFieldNames()!=null && getClassifyingFieldNames().length>0){
-			name = feat.getString(getClassifyingFieldNames()[0]);
-		}
-		else{
-			return null;
-		}
-		Set<String> indexes = getLinkedFieldValues();
-		if(!indexes.contains(name)){
-			return null;
-		}
+    private void addPieDataSetInfo(ChartDataSet dataSet, String name) {
 
-		// TODO: AQUÍ PRODRÍAMOS RECUPERAR VARIOS SIMBOLOS. POR AHORA, SUPONEMOS QUE EL DEFAULTSYMBOL ES EL QUE TIENE EL CHARTSYMBOL
-		symbol = (IChartSymbol) getDefaultSymbol();
-		if (symbol==null){
-			symbol = (IChartSymbol) MapContextLocator
-				.getSymbolManager().createSymbol(IChartSymbol.SYMBOL_NAME);
+        String[] names = getFieldNames();
+        String[] _labels = getFieldLabels();
+        if (names != null && _labels != null && _labels.length == names.length) {
+            ArrayList serie = new ArrayList();
+            ArrayList category = new ArrayList();
+            ArrayList groupedBy = new ArrayList();
 
-		}
-		symbol.setOnlySelection(onlySelection);
-		double size=0;
+            Iterator it = indexHash.get(name).iterator();
+            int ji = 1;
+            while (it.hasNext()) {
+                Map<String, Object> it_next = (Map<String, Object>) it.next();
 
-			ChartDataSet dataSet = ChartLocator.getServiceManager()
-				.getChartManager().createChartDataSet();
+                for (int i = 0; i < names.length; i++) {
+                    if (getGroupedField() != null && getGroupedField() != "") {
+                        groupedBy.add("" + it_next.get(getGroupedField()));
+                    } else {
+                        if (ji != 1 || (ji == 1 && it.hasNext())) {
+                            groupedBy.add("" + ji);
+                        } else {
+                            groupedBy.add(" ");
+                        }
+                    }
+                    double val = (Double) it_next.get(names[i]);
+                    if (sizeOption == IChartSymbol.SIZESUM) {
+                        size += val;
+                    }
+                    serie.add(_labels[i]);
+                    category.add(val);
+                }
+                ji++;
+            }
 
+            dataSet.addData("groupby", groupedBy);
+            dataSet.addData("series", serie);
+            dataSet.addData("categories", category);
 
-			ChartService cs = symbol.getChart();
-			if(cs.getChartType()=="BarsChart"){
-				addBarsDataSetInfo(dataSet, name);
-			}else{
-				addPieDataSetInfo(dataSet, name);
-			}
-			cs.getChartProperties().setChartDimension(this.is3D);
+        }
+    }
 
-		String[] names=getFieldNames();
-		if (names!=null){
-			//ChartDataSet dataSet = createSeriesCollection(feat);
+    private void addBarsDataSetInfo(ChartDataSet dataSet, String name) {
+        String[] names = getFieldNames();
+        if (names != null) {
+            ArrayList serie = new ArrayList();
+            ArrayList category = new ArrayList();
+            ArrayList groupedBy = new ArrayList();
 
-			cs.setChartDataSet(dataSet);
+            Iterator it = indexHash.get(name).iterator();
+            int ji = 1;
+            while (it.hasNext()) {
+                Map<String, Object> it_next = (Map<String, Object>) it.next();
 
-//			cs.createChartLegendItems();
-			List<ChartSerieEntity> lst  = cs.getChartLegendItems();
+                for (int i = 0; i < names.length; i++) {
+                    if (getGroupedField() != null && getGroupedField() != "") {
+                        serie.add("" + it_next.get(getGroupedField()));
+                    } else {
+                        serie.add("" + ji);
+                    }
+                    double val = (Double) it_next.get(names[i]);
+                    if (sizeOption == IChartSymbol.SIZESUM) {
+                        size += val;
+                    }
+                    groupedBy.add(names[i]);
+                    category.add(val);
+                }
+                ji++;
+            }
 
-            for (int j=0; j < names.length; j++) {
-                colors[j] = getSymbolByValue(names[j]).getColor();
-                LegendItem item = new LegendItem(names[j], colors[j]);
-				item.setSeriesKey(names[j]);
-				ChartSerieEntity e = cs.createNewChartSerieEntity(item);
-				if(e!=null)
-					lst.add(e);
-			}
-            cs.setCategoriesPaint(Arrays.asList(colors));
-		}
-		double separation = sizeTo-sizeFrom;
+            dataSet.addData("groupby", groupedBy);
+            dataSet.addData("series", serie);
+            dataSet.addData("categories", category);
+        }
+    }
 
-		if (sizeOption==IChartSymbol.SIZESUM){
-			if (isActiveLimits()){
-				double difFeat = maxFeature - minFeature;
-				double step = difFeat/separation;
-				size = sizeFrom + ((size - minFeature)/step);
-			}
-			symbol.setSize(size);
-		}else if (sizeOption==IChartSymbol.SIZEFIELD){
-			if(separation == 0)
-				separation = 1;
-			double value=feat.getDouble(getFieldSize());
+    @Override
+    public String getLinkedField() {
+        return this.linkedField;
+    }
 
-			if (!getFieldNormalize().equals("---")){
-				double normalize=feat.getDouble(getFieldNormalize());
-				if (normalize!=0){
-					value= value/normalize;
-				}
-				if (isActiveLimits())
-					size = sizeFrom + (value * separation) ;
-				else
-					size=value;
-			}else{
-				if (isActiveLimits()){
-					double difFeat = maxFeature - minFeature;
-					double step = difFeat/separation;
-					size = sizeFrom + ((value - minFeature)/step);
-				}else{
-					size=value;
-				}
-			}
-			symbol.setSize(size);
-		}else{
-			symbol.setSize(getSize());
-		}
-//		JFreeChart theChart=configureBarChart(dataSet);
-//		symbol.setChart(theChart);
+    @Override
+    public void setLinkedField(String field) {
+        this.linkedField = field;
+    }
 
-//		if (backgroundSymbol!=null){
-//			multiChartSymbol multiChartSymbol=new MultiChartSymbol();
-//			multiChartSymbol.addLayer(backgroundSymbol);
-//			multiChartSymbol.addLayer(symbol);
-//			return multiChartSymbol;
-//		}
-		return symbol;
-	}
+    @Override
+    public String getTimeField() {
+        return this.timeField;
+    }
 
-	private void addPieDataSetInfo(ChartDataSet dataSet, String name) {
+    @Override
+    public void setTimeField(String field) {
+        this.timeField = field;
+    }
 
-		String[] names=getFieldNames();
-		String[] labels=getFieldLabels();
-		if (names!=null && labels != null && labels.length == names.length){
-			ArrayList serie = new ArrayList();
-			ArrayList category = new ArrayList();
-			ArrayList groupedBy = new ArrayList();
+    @Override
+    public String getLegendType() {
+        return this.legendType;
+    }
 
-				Iterator it = indexHash.get(name).iterator();
-				int ji = 1;
-				while(it.hasNext()){
-					Map<String,Object> it_next = (Map<String, Object>) it.next();
+    @Override
+    public void setLegendType(String field) {
+        this.legendType = field;
+    }
 
-					for (int i = 0; i < names.length; i++) {
-						if(getGroupedField()!=null && getGroupedField()!= ""){
-							groupedBy.add(""+it_next.get(getGroupedField()));
-						}else{
-							if(ji!=1 || (ji==1 && it.hasNext())){
-								groupedBy.add(""+ji);
-							}else{
-								groupedBy.add(" ");
-							}
-						}
-						double val = (Double) it_next.get(names[i]);
-						if (sizeOption==IChartSymbol.SIZESUM){
-							size+=val;
-						}
-						serie.add(labels[i]);
-						category.add(val);
-					}
-					ji++;
-				}
+    @Override
+    public void setGroupedField(String string) {
+        this.groupedByField = string;
+    }
 
-			dataSet.addData("groupby", groupedBy);
-			dataSet.addData("series", serie);
-			dataSet.addData("categories", category);
+    @Override
+    public String getGroupedField() {
+        return this.groupedByField;
+    }
 
-		}
-	}
+    @Override
+    public String getLinkedTable() {
+        return this.linkedTable;
+    }
 
-	private void addBarsDataSetInfo(ChartDataSet dataSet, String name) {
-		String[] names=getFieldNames();
-		if (names!=null){
-			ArrayList serie = new ArrayList();
-			ArrayList category = new ArrayList();
-			ArrayList groupedBy = new ArrayList();
+    @Override
+    public boolean getLinkedSelected() {
+        return this.destinationSelected;
+    }
 
-				Iterator it = indexHash.get(name).iterator();
-				int ji = 1;
-				while(it.hasNext()){
-					Map<String,Object> it_next = (Map<String, Object>) it.next();
+    @Override
+    public String[] getOriginFieldName() {
+        return linkedFieldName;
+    }
 
-					for (int i = 0; i < names.length; i++) {
-						if(getGroupedField()!=null && getGroupedField()!= ""){
-							serie.add(""+it_next.get(getGroupedField()));
-						}else{
-							serie.add(""+ji);
-						}
-						double val = (Double) it_next.get(names[i]);
-						if (sizeOption==IChartSymbol.SIZESUM){
-							size+=val;
-						}
-						groupedBy.add(names[i]);
-						category.add(val);
-					}
-					ji++;
-				}
+    @Override
+    public boolean getOriginSelected() {
+        return this.originSelected;
+    }
 
-			dataSet.addData("groupby", groupedBy);
-			dataSet.addData("series", serie);
-			dataSet.addData("categories", category);
-		}
-	}
+    @Override
+    public void setLinkedTable(String selectedItem) {
+        this.linkedTable = selectedItem;
+        updateSymbols();
+    }
 
-	public String getLinkedField() {
-		return this.linkedField;
-	}
+    @Override
+    public void setOriginSelected(boolean selected) {
+        this.originSelected = selected;
+    }
 
-	public void setLinkedField(String field){
-		this.linkedField = field;
-	}
+    @Override
+    public void setLinkedSelected(boolean selected) {
+        this.destinationSelected = selected;
+    }
 
-	public String getTimeField() {
-		return this.timeField;
-	}
+    @Override
+    public void setLinkedFields(String[] fields) {
+        this.linkedFields = fields;
+        updateSymbols();
+    }
 
-	public void setTimeField(String field){
-		this.timeField = field;
-	}
+    @Override
+    public String[] getLinkedFields() {
+        return linkedFields;
+    }
 
-	public String getLegendType() {
-		return this.legendType;
-	}
+    @Override
+    public void loadFromState(PersistentState state)
+            throws PersistenceException {
+        // Set parent properties
+        super.loadFromState(state);
 
-	public void setLegendType(String field){
-		this.legendType = field;
-	}
+        this.linkedFields = state.getStringArray("linkedFields");
+        this.linkedFieldName = state.getStringArray("linkedFieldName");
+        this.linkedFieldTableNames = state.getStringArray("linkedFieldTableNames");
 
-	public void setGroupedField(String string) {
-		this.groupedByField = string;
-	}
+        // Set own properties
+        this.linkedFieldValues = (List<String>) state.getList("linkedFieldValues");
 
-	public String getGroupedField(){
-		return this.groupedByField;
-	}
+        this.originSelected = state.getBoolean("originSelected");
+        this.destinationSelected = state.getBoolean("destinationSelected");
 
-	public String getLinkedTable() {
-		return this.linkedTable;
-	}
+        this.linkedTable = state.getString("linkedTable");
+        this.linkedField = state.getString("linkedField");
+        this.groupedByField = state.getString("groupedByField");
+        this.timeField = state.getString("timeField");
+        this.legendType = state.getString("legendType");
 
-	public boolean getLinkedSelected() {
-		return this.destinationSelected;
-	}
+        this.indexHash = state.getMap("indexHash");
 
-	public String[] getOriginFieldName() {
-		return linkedFieldName;
-	}
+        //getLinkedData();
+    }
 
-	public boolean getOriginSelected() {
-		return this.originSelected;
-	}
+    @Override
+    public void saveToState(PersistentState state) throws PersistenceException {
+        // Save parent properties
+        super.saveToState(state);
+        // Save own properties
+        state.set("linkedFields", this.linkedFields);
+        state.set("linkedFieldName", this.linkedFieldName);
+        state.set("linkedFieldTableNames", this.linkedFieldTableNames);
 
-	public void setLinkedTable(String selectedItem) {
-		this.linkedTable = selectedItem;
-		updateSymbols();
-	}
+        state.set("linkedFieldValues", this.linkedFieldValues);
 
-	public void setOriginSelected(boolean selected) {
-		this.originSelected = selected;
-	}
+        state.set("originSelected", this.originSelected);
+        state.set("destinationSelected", this.destinationSelected);
 
-	public void setLinkedSelected(boolean selected) {
-		this.destinationSelected = selected;
-	}
+        state.set("linkedTable", this.linkedTable);
+        state.set("linkedField", this.linkedField);
+        state.set("groupedByField", this.groupedByField);
+        state.set("timeField", this.timeField);
 
-	public void setLinkedFields(String[] fields) {
-		this.linkedFields = fields;
-		updateSymbols();
-	}
+        state.set("legendType", this.legendType);
 
-	public String[] getLinkedFields() {
-		return linkedFields;
-	}
+        state.set("indexHash", this.indexHash);
+    }
 
-	public void loadFromState(PersistentState state)
-	throws PersistenceException {
-		// Set parent properties
-		super.loadFromState(state);
+    public static class RegisterPersistence implements Callable {
 
-		this.linkedFields = state.getStringArray("linkedFields");
-		this.linkedFieldName = state.getStringArray("linkedFieldName");
-		this.linkedFieldTableNames = state.getStringArray("linkedFieldTableNames");
+        @Override
+        public Object call() throws Exception {
+            PersistenceManager manager = ToolsLocator.getPersistenceManager();
+            if (manager.getDefinition(LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME) == null) {
+                DynStruct definition = manager.addDefinition(
+                        LinkedChartLegend.class,
+                        LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME,
+                        LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME + " Persistence definition",
+                        null,
+                        null
+                );
+                // Extend the Classified Vector Legend base definition
+                definition.extend(manager.getDefinition(VECTORIAL_UNIQUE_VALUE_LEGEND_PERSISTENCE_DEFINITION_NAME));
 
+                // Field names
+                definition.addDynFieldArray(FIELD_NAMES)
+                        .setClassOfItems(String.class);
+                definition.addDynFieldArray(FIELD_LABEL_NAMES)
+                        .setClassOfItems(String.class);
+                definition.addDynFieldArray(FIELD_LABEL_COLOR)
+                        .setClassOfItems(Color.class);
 
-		// Set own properties
-		this.linkedFieldValues = (List<String>) state.getList("linkedFieldValues");
+                definition.addDynField("backgroundSymbol").setClassOfValue(ISymbol.class);
+                definition.addDynFieldInt("size");
+                definition.addDynFieldBoolean("is3D");
 
-		this.originSelected = state.getBoolean("originSelected");
-		this.destinationSelected = state.getBoolean("destinationSelected");
+                definition.addDynFieldBoolean("isOutlineShow");
+                definition.addDynFieldBoolean("onlySelection");
+                definition.addDynFieldBoolean("isActiveLimits");
 
-		this.linkedTable = state.getString("linkedTable");
-		this.linkedField = state.getString("linkedField");
-		this.groupedByField = state.getString("groupedByField");
-		this.timeField = state.getString("timeField");
-		this.legendType = state.getString("legendType");
+                definition.addDynFieldInt("outlineWidth");
+                definition.addDynFieldInt("referenceSystem");
+                definition.addDynFieldInt("sizeFrom");
+                definition.addDynFieldInt("sizeTo");
+                definition.addDynFieldInt("unit");
+                definition.addDynFieldInt("sizeOption");
 
-		this.indexHash = state.getMap("indexHash");
+                definition.addDynFieldObject("outlineColor").setClassOfValue(Color.class);
+                definition.addDynFieldObject("symbol").setClassOfValue(IChartSymbol.class);
+                definition.addDynFieldObject("featSelection").setClassOfValue(FeatureSelection.class);
 
-		//getLinkedData();
-	}
+                definition.addDynFieldString("fieldSize");
+                definition.addDynFieldString("fieldNormalize");
 
-	public void saveToState(PersistentState state) throws PersistenceException {
-		// Save parent properties
-		super.saveToState(state);
-		// Save own properties
-		state.set("linkedFields", this.linkedFields);
-		state.set("linkedFieldName", this.linkedFieldName);
-		state.set("linkedFieldTableNames", this.linkedFieldTableNames);
+                definition.addDynFieldDouble("minFeature");
+                definition.addDynFieldDouble("maxFeature");
+                definition.addDynFieldDouble("maxField");
 
-		state.set("linkedFieldValues", this.linkedFieldValues);
+                // Field names
+                definition.addDynFieldArray("linkedFields")
+                        .setClassOfItems(String.class);
+                definition.addDynFieldArray("linkedFieldName")
+                        .setClassOfItems(String.class);
+                definition.addDynFieldArray("linkedFieldTableNames")
+                        .setClassOfItems(String.class);
+                definition.addDynFieldList("linkedFieldValues")
+                        .setClassOfItems(String.class);
 
-		state.set("originSelected", this.originSelected);
-		state.set("destinationSelected", this.destinationSelected);
+                definition.addDynFieldBoolean("originSelected");
+                definition.addDynFieldBoolean("destinationSelected");
 
-		state.set("linkedTable", this.linkedTable);
-		state.set("linkedField", this.linkedField);
-		state.set("groupedByField", this.groupedByField);
-		state.set("timeField", this.timeField);
+                definition.addDynFieldString("linkedTable");
+                definition.addDynFieldString("linkedField");
+                definition.addDynFieldString("groupedByField");
+                definition.addDynFieldString("timeField");
 
-		state.set("legendType", this.legendType);
+                definition.addDynFieldMap("indexHash").setClassOfItems(List.class);
+                definition.addDynFieldString("legendType");
 
-		state.set("indexHash", this.indexHash);
-	}
+            }
+            return Boolean.TRUE;
+        }
 
-	public static class RegisterPersistence implements Callable {
-
-		public Object call() throws Exception {
-			PersistenceManager manager = ToolsLocator.getPersistenceManager();
-			if( manager.getDefinition(LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME)==null ) {
-				DynStruct definition = manager.addDefinition(
-						LinkedChartLegend.class,
-						LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME,
-						LINKED_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME+" Persistence definition",
-						null,
-						null
-				);
-				// Extend the Classified Vector Legend base definition
-				definition.extend(manager.getDefinition(PIE_CHART_LEGEND_PERSISTENCE_DEFINITION_NAME));
-
-				// Field names
-				definition.addDynFieldArray("linkedFields")
-					.setClassOfItems(String.class);
-				definition.addDynFieldArray("linkedFieldName")
-					.setClassOfItems(String.class);
-				definition.addDynFieldArray("linkedFieldTableNames")
-					.setClassOfItems(String.class);
-				definition.addDynFieldList("linkedFieldValues")
-					.setClassOfItems(String.class);
-
-				definition.addDynFieldBoolean("originSelected");
-				definition.addDynFieldBoolean("destinationSelected");
-
-				definition.addDynFieldString("linkedTable");
-				definition.addDynFieldString("linkedField");
-				definition.addDynFieldString("groupedByField");
-				definition.addDynFieldString("timeField");
-
-				definition.addDynFieldMap("indexHash").setClassOfItems(List.class);
-				definition.addDynFieldString("legendType");
-
-			}
-			return Boolean.TRUE;
-		}
-
-	}
+    }
 }
